;GoatTracker song tweak utility

                processor 6502
                org 2048

SCREEN_SONG     = 0
SCREEN_PATT     = 1
SCREEN_INSTR    = 2
SCREEN_FILTER   = 3
SCREEN_WAVE     = 4

        ;Zeropage variables
textlo          = $02
texthi          = $03
destlo          = $04
desthi          = $05
storea          = $06
storex          = $07
storey          = $08
trklo           = $09
trkhi           = $0a
editlo          = $0b
edithi          = $0c
freememlo       = $0d
freememhi       = $0e
temp1           = $0f
temp2           = $10
temp3           = $11
temp4           = $12
temp5           = $13
status          = $90
fa              = $ba

        ;Kernal routines
scnkey          = $ff9f
getin           = $ffe4
setnam          = $ffbd
setlfs          = $ffba
load            = $ffd5
save            = $ffd8
chrin           = $ffcf
open            = $ffc0
close           = $ffc3
chkin           = $ffc6
chkout          = $ffc9
clrchn          = $ffcc
chrout          = $ffd2
plot            = $fff0

        ;Some keycodes
KEY_F1          = $85
KEY_F3          = $86
KEY_F5          = $87
KEY_F7          = $88
KEY_UP          = $91
KEY_DOWN        = $11
KEY_LEFT        = $9d
KEY_RIGHT       = $1d
KEY_INS         = $94
KEY_DEL         = $14
KEY_BREAK       = $03

start:          cld
                lda fa                  ;Find out drive number
                cmp #$08
                bcs driveok
                lda #$08
driveok:        sta drivenumber
                lda #$36                ;Switch off BASIC-rom
                sta $01
                jsr music+6             ;Make sure music is stopped
                jsr initscreen
                jsr initraster
                lda #$01
                sta textcolor
                lda #$80
                sta bgcolor
                ldx #0
                ldy #0
                jsr setxy
                ldx #<titletext
                ldy #>titletext
                jsr printtext
                lda #$00
                sta bgcolor
                inc cursory
                jsr printtextcont
                inc cursory
                jsr printtextcont

printall:       jsr printsong
                jsr printpatt
                jsr printinstr
                jsr printwave
                jsr printfilter
branchtoscreen: lda screennum
                asl
                tax
                lda screenjumptbl,x
                sta bts_jump+1
                lda screenjumptbl+1,x
                sta bts_jump+2
bts_jump:       jmp $0000

nextscreen:     lda screennum
                clc
                adc #$01
                cmp #$05
                bcc ns_ok
                lda #$00
ns_ok:          sta screennum
                jmp printall

screenjumptbl:  dc.w editsong
                dc.w editpatt
                dc.w editinstr
                dc.w editfilter
                dc.w editwave

editfilter:     jsr printfilter
                jsr commonkeys
                lda keynum
                cmp #":"
                bne ef_nofiltselect1
                dec curfilter
ef_fscommon:    lda curfilter
                and #$3f
                sta curfilter
                jmp editfilter
ef_nofiltselect1:
                cmp #";"
                bne ef_nofiltselect2
                inc curfilter
                jmp ef_fscommon
ef_nofiltselect2:
                cmp #KEY_LEFT
                bne ef_notleft
                jsr cursormoveleft
                bcc ef_back
                lda filtervx
                beq ef_back
                dec filtervx
ef_back:        jmp editfilter
ef_notleft:     cmp #KEY_RIGHT
                bne ef_notright
ef_right:       jsr cursormoveright
                bcc ef_back
                lda filtervx
                cmp #$03
                bcs ef_back
                inc filtervx
                jmp editfilter
ef_notright:    lda hexdigit
                bmi ef_nohex
                lda curfilter
                asl
                asl
                adc filtervx
                adc #<filtertbl
                sta editlo
                lda #$00
                adc #>filtertbl
                sta edithi
                jsr edithex
                bcc ef_nohex
                jmp ef_right
ef_nohex:       jmp editfilter

editsong:       jsr printsong
                jsr commonkeys
                lda keynum
                cmp #13
                bne es_noreturn
                ldx trackvy
                lda trackadrlo,x
                clc
                adc trackvx
                sta editlo
                lda trackadrhi,x
                adc #$00
                sta edithi
                ldy #$00
                lda (editlo),y
                cmp #208
                bcs es_pattnotok
                sta curpatt
                lda #SCREEN_PATT
                jmp ns_ok
es_pattnotok:   jmp editsong
es_noreturn:    cmp #":"
                bne es_nosongselect1
                lda cursong
                beq editsong
                dec cursong
es_settrack:    lda cursong
                asl
                adc cursong
                sta trackvy
                sta trackmin
                clc
                adc #$02
                sta trackmax
                lda #$00
                sta trackvx
                jmp editsong
es_nosongselect1:
                cmp #";"
                bne es_nosongselect2
                inc cursong
                lda cursong
                asl
                adc cursong
                tax
                lda tracklen,x
                bne es_settrack
                dec cursong
                jmp editsong
es_nosongselect2:
                cmp #KEY_UP
                bne es_notup
                lda trackvy
                cmp trackmin
                bne es_upok
                jmp editsong
es_upok:        dec trackvy
es_checkend:    ldx trackvy
                lda trackvx
                cmp tracklen,x
                bne es_upok2
                lda #$00
                sta trackvx
es_upok2:       jmp editsong
es_notup:       cmp #KEY_DOWN
                bne es_notdown
                lda trackvy
                cmp trackmax
                bne es_downok
                jmp editsong
es_downok:      inc trackvy
                jmp es_checkend
es_notdown:     cmp #KEY_LEFT
                bne es_notleft
                jsr cursormoveleft
                bcc es_back
                lda trackvx
                bne es_leftok
                jmp editsong
es_leftok:      dec trackvx
es_back:        jmp editsong
es_notleft:     cmp #KEY_RIGHT
                bne es_notright
                jsr cursormoveright
                bcc es_back
es_right:       ldx trackvy
                lda trackvx
                clc
                adc #$01
                cmp tracklen,x
                bcc es_rightok
                jmp editsong
es_rightok:     inc trackvx
                jmp editsong
es_notright:    lda hexdigit
                bmi es_nohex
                ldx trackvy
                lda trackadrlo,x
                clc
                adc trackvx
                sta editlo
                lda trackadrhi,x
                adc #$00
                sta edithi
                jsr edithex
                bcc es_nohex
                jmp es_right
es_nohex:       jmp editsong

edithex:        ldy #$00
                lda cursordigit
                bne editlownybble
edithighnybble: lda hexdigit
                asl
                asl
                asl
                asl
                sta temp1
                lda (editlo),y
                and #$0f
                ora temp1
                sta (editlo),y
                inc cursordigit
                clc
                rts

editlownybble:  lda (editlo),y
                and #$f0
                ora hexdigit
                sta (editlo),y
                lda #$00
                sta cursordigit
                sec
                rts

editpatt:       jsr printpatt
                jsr commonkeys
                lda keynum
                cmp #":"
                bne ep_nopattselect1
                lda curpatt
                bne ep_ps1ok
                jmp editpatt
ep_ps1ok:       dec curpatt
ep_pscommon:    lda #$00
                sta pattvx
                sta pattvy
                jmp editpatt
ep_nopattselect1:
                cmp #";"
                bne ep_nopattselect2
                lda curpatt
                clc
                adc #$01
                cmp maxpatt
                bcc ep_ps2ok
                jmp editpatt
ep_ps2ok:       inc curpatt
                jmp ep_pscommon
ep_nopattselect2:
                cmp #KEY_UP
                bne ep_notup
                dec pattvy
                lda pattvy
                cmp #$ff
                bne ep_upok
                ldx curpatt
                lda pattlen,x
                sta pattvy
                dec pattvy
ep_upok:        jmp editpatt
ep_notup:       cmp #KEY_DOWN
                bne ep_notdown
ep_down:        inc pattvy
                ldx curpatt
                lda pattvy
                cmp pattlen,x
                bcc ep_upok
                lda #$00
                sta pattvy
                jmp editpatt
ep_notdown:     cmp #KEY_LEFT
                bne ep_notleft
                jsr cursormoveleft
                bcc ep_leftok
                dec pattvx
                bpl ep_leftok
                lda #$02
                sta pattvx
ep_leftok:      jmp editpatt
ep_notleft:     cmp #KEY_RIGHT
                bne ep_notright
                jsr cursormoveright
                bcc ep_leftok
                inc pattvx
                lda pattvx
                cmp #$03
                bcc ep_leftok
                lda #$00
                sta pattvx
                jmp editpatt
ep_notright:    lda hexdigit
                bmi ep_nothex
                lda pattvy
                ldx curpatt
                jsr multiply
                lda temp3
                clc
                adc pattvx
                sta editlo
                lda temp4
                adc #$00
                sta edithi
                jsr edithex
                bcc ep_nothex
                jmp ep_down
ep_nothex:      jmp editpatt

editinstr:      jsr printinstr
                jsr commonkeys
                lda keynum
                cmp #":"
                bne ei_noselect1
                lda curinstr
                cmp #$02
                bcs ei_select1ok
                jmp editinstr
ei_select1ok:   dec curinstr
                jmp editinstr
ei_noselect1:   cmp #";"
                bne ei_noselect2
                lda curinstr
                clc
                adc #$01
                cmp maxinstr
                bcc ei_select2ok
                jmp editinstr
ei_select2ok:   inc curinstr
                jmp editinstr
ei_noselect2:   cmp #KEY_DOWN
                bne ei_notdown
ei_down:        inc instrvy
                lda instrvy
                cmp #$07
                bcc ei_downok
                lda #$00
                sta instrvy
ei_downok:      jmp editinstr
ei_notdown:     cmp #KEY_UP
                bne ei_notup
                dec instrvy
                bpl ei_upok
                lda #$06
                sta instrvy
ei_upok:        jmp editinstr
ei_notup:       cmp #KEY_LEFT
                beq ei_cursor
                cmp #KEY_RIGHT
                bne ei_nocursor
ei_cursor:      jsr cursormoveleft
                jmp editinstr
ei_nocursor:    lda hexdigit
                bmi ei_nothex
                lda instrvy
                sta editlo
                lda #$00
                sta edithi
                ldy #$05
ei_multiply:    asl editlo
                rol edithi
                dey
                bne ei_multiply
                lda #<instrad
                clc
                adc editlo
                sta editlo
                lda #>instrad
                adc edithi
                sta edithi
                lda curinstr
                clc
                adc editlo
                sta editlo
                bcc ei_ok
                inc edithi
ei_ok:          jsr edithex
                bcc ei_nothex
                jmp ei_down
ei_nothex:      jmp editinstr

editwave:       jsr printwave
                jsr commonkeys
                lda keynum
                cmp #KEY_DOWN
                bne ew_notdown
ew_down:        inc wavevy
                lda wavevy
                cmp wavelen
                bcc ew_downok
                lda #$00
                sta wavevy
ew_downok:      jmp editwave
ew_notdown:     cmp #KEY_UP
                bne ew_notup
                dec wavevy
                lda wavevy
                cmp #$ff
                bne ew_upok
                lda wavelen
                sec
                sbc #$01
                sta wavevy
ew_upok:        jmp editwave
ew_notup:       cmp #KEY_LEFT
                bne ew_notleft
                jsr cursormoveleft
                bcc ew_upok
                jmp ew_left
ew_notleft:     cmp #KEY_RIGHT
                bne ew_notright
                jsr cursormoveright
                bcc ew_upok
ew_left:        lda wavevx
                eor #$01
                sta wavevx
                jmp editwave
ew_notright:    lda hexdigit
                bmi ew_nothex
                lda #<wavetbl
                ldx #>wavetbl
                ldy wavevx
                beq ew_adrok
                lda #<notetbl
                ldx #>notetbl
ew_adrok:       clc
                adc wavevy
                sta editlo
                txa
                adc #$00
                sta edithi
                jsr edithex
                bcc ew_nothex
                jmp ew_down
ew_nothex:      jmp editwave

cursormoveleft: dec cursordigit
                bpl cml_ok
                lda #$01
                sta cursordigit
                sec
                rts
cml_ok:         clc
                rts

cursormoveright:inc cursordigit
                lda cursordigit
                cmp #$02
                bcc cmr_ok
                lda #$00
                sta cursordigit
cmr_ok:         rts

commonkeys:     jsr getkey
                sta keynum
                cmp #KEY_F1
                bne ck_noswitch
                pla
                pla
                jmp nextscreen
ck_noswitch:    cmp #$20
                bne ck_noplay
                lda playing
                eor #$01
                sta playing
                beq ck_stop
ck_play:        lda #$00
                sta fastfwd
                lda cursong
                jmp music
ck_stop:        jmp music+6
ck_noplay:      cmp #$a0
                bne ck_nofast
                inc fastfwd
                rts
ck_nofast:      cmp #"L"
                bne ck_noload
                jsr loadsong
ck_loadcommon:  pla
                pla
                jmp printall
ck_noload:      cmp #"S"
                bne ck_nosave
                jsr music+6
                jsr savesong
                jmp ck_loadcommon
ck_nosave:      rts

printsong:      lda trackvy
                sec
                sbc #$01
                sta temp1                       ;Track view Y-pos
                lda #$00                        ;Row counter
                sta temp2
pts_loop:       lda #$00
                sta bgcolor
                lda #$01
                sta textcolor
                lda temp2
                clc
                adc #$04
                tay
                ldx #$00
                jsr setxy
                lda temp1
                cmp maxtracks
                bcc pts_notempty
                jmp pts_empty
pts_notempty:   ldx temp1
                lda trknumtbl1,x
                sta pts_text+3
                lda trknumtbl2,x
                sta pts_text+4
                lda trknumtbl3,x
                sta pts_text+9
                lda trackadrlo,x
                sta temp4
                lda trackadrhi,x
                sta temp5
                lda #$01
                sta textcolor
                ldx #<pts_text
                ldy #>pts_text
                jsr printtext
                lda #11
                sta cursorx
                lda trackvx
                sec
                sbc #$04
                sta temp3               ;Track view X-pos
                lda #$0f
                sta textcolor
pts_xloop:      lda #$00
                sta bgcolor
                lda trackvx
                cmp temp3
                bne pts_nocursor
                lda trackvy
                cmp temp1
                bne pts_nocursor
                lda screennum
                cmp #SCREEN_SONG
                bne pts_nocursor
                lda #$c0
                sta bgcolor
pts_nocursor:   ldx temp1
                lda temp3
                cmp tracklen,x
                bcs pts_xempty
                tay
                lda (temp4),y
                jsr printhex8
                jmp pts_xdone
pts_xempty:     ldx #<pts_emptytxt2
                ldy #>pts_emptytxt2
                jsr printtext
pts_xdone:      inc temp3
                lda cursorx
                clc
                adc #$03
                sta cursorx
                lda cursorx
                cmp #39
                bcc pts_xloop
                jmp pts_done
pts_empty:      jsr printemptyrow
pts_done:       inc temp1
                inc temp2
                lda temp2
                cmp #$03
                bcs pts_alldone
                jmp pts_loop
pts_alldone:    rts

pts_text:       dc.b "SNG00 TRK0",0
pts_emptytxt2:  dc.b "  ",0

printpatt:      lda #$00
                sta bgcolor
                ldx #0
                ldy #8
                jsr setxy
                lda #$01
                sta textcolor
                ldx #<ptp_text
                ldy #>ptp_text
                jsr printtext
                lda #7
                sta cursorx
                lda curpatt
                jsr printhex8
                lda pattvy
                sec
                sbc #$07
                sta temp1
                lda #10
                sta temp2
ptp_loop:       ldx #$00
                stx bgcolor
                ldy temp2
                jsr setxy
                ldx curpatt
                lda temp1
                cmp pattlen,x
                bcs ptp_empty
                jsr multiply
                lda #$01
                sta textcolor
                lda temp1
                jsr printhex8
                lda #$0f
                sta textcolor
                lda #$03
                sta cursorx
                ldy #0
                jsr pattcursor
                lda (temp3),y
                jsr printhex8
                lda #$06
                sta cursorx
                ldy #1
                jsr pattcursor
                lda (temp3),y
                jsr printhex8
                lda #$09
                sta cursorx
                ldy #2
                jsr pattcursor
                lda (temp3),y
                jsr printhex8
                jmp ptp_done
ptp_empty:      ldx #<ptp_emptytxt
                ldy #>ptp_emptytxt
                jsr printtext
ptp_done:       inc temp1
                inc temp2
                lda temp2
                cmp #24
                bcs ptp_alldone
                jmp ptp_loop
ptp_alldone:    rts

pattcursor:     cpy pattvx
                bne pattcursoroff
                lda temp1
                cmp pattvy
                bne pattcursoroff
                lda screennum
                cmp #SCREEN_PATT
                bne pattcursoroff
                lda #$c0
                sta bgcolor
                rts
pattcursoroff:  lda #$00
                sta bgcolor
                rts

multiply:       sta ptp_muladd+1
                lda #$00
                sta temp3
                sta temp4
                ldy #$03
ptp_multiply:   lda temp3
                clc
ptp_muladd:     adc #$00
                sta temp3
                lda temp4
                adc #$00
                sta temp4
                dey
                bne ptp_multiply
                lda pattadrlo,x
                clc
                adc temp3
                sta temp3
                lda pattadrhi,x
                adc temp4
                sta temp4
                rts

ptp_text:       dc.b "PATTERN",0
ptp_emptytxt:   dc.b "           ",0

printinstr:     lda #$00
                sta bgcolor
                ldx #13
                ldy #8
                jsr setxy
                lda #$01
                sta textcolor
                ldx #<pti_text
                ldy #>pti_text
                jsr printtext
                inc cursory
                inc cursory
                inc cursory
                jsr printtextcont
                inc cursory
                jsr printtextcont
                inc cursory
                jsr printtextcont
                inc cursory
                jsr printtextcont
                inc cursory
                jsr printtextcont
                inc cursory
                jsr printtextcont
                inc cursory
                jsr printtextcont
                inc cursory
                jsr printtextcont
                ldx #23
                ldy #8
                jsr setxy
                lda curinstr
                jsr printhex8
                lda #$0f
                sta textcolor
                inc cursory
                inc cursory
                inc cursory
                tax
                lda #<instrnames
                sta printname+1
                lda #>instrnames
                sta printname+2
                ldy curinstr
printnameadr:   dey
                beq printname
                lda printname+1
                clc
                adc #$10
                sta printname+1
                bcc printnameadr
                inc printname+2
                bcs printnameadr
printname:      lda instrnames,x
                bne printname_nozero
                lda #$20
printname_nozero:
                cmp #96
                bcc printname_uppercase
                sbc #96
printname_uppercase:
                and #$3f
                sta $0400+9*40+13,x
                lda #$0f
                sta $d800+9*40+13,x
                dex
                bpl printname
                ldx curinstr
                ldy #$00
                jsr instrcursor
                lda instrad,x
                jsr printhex8
                inc cursory
                ldx curinstr
                ldy #$01
                jsr instrcursor
                lda instrsr,x
                jsr printhex8
                inc cursory
                ldx curinstr
                ldy #$02
                jsr instrcursor
                lda instrpulse,x
                jsr printhex8
                inc cursory
                ldx curinstr
                ldy #$03
                jsr instrcursor
                lda instrpulsespd,x
                jsr printhex8
                inc cursory
                ldx curinstr
                ldy #$04
                jsr instrcursor
                lda instrpulsemin,x
                jsr printhex8
                inc cursory
                ldx curinstr
                ldy #$05
                jsr instrcursor
                lda instrpulsemax,x
                jsr printhex8
                inc cursory
                ldx curinstr
                ldy #$06
                jsr instrcursor
                lda instrfilter,x
                jsr printhex8
                inc cursory
                ldx curinstr
                ldy #$07
                jsr instrcursor
                lda instrwaveindex,x
                jsr printhex8
                rts

instrcursor:    lda screennum
                cmp #SCREEN_INSTR
                bne instrcursoroff
                cpy instrvy
                bne instrcursoroff
                lda #$c0
                sta bgcolor
                rts
instrcursoroff: lda #$00
                sta bgcolor
                rts

pti_text:       dc.b "INSTRUMENT",0
pti_text2:      dc.b "ATK/DEC",0
pti_text3:      dc.b "SUS/REL",0
pti_text4:      dc.b "PULSE",0
pti_text5:      dc.b "PULSE SPD",0
pti_text6:      dc.b "PULSE MIN",0
pti_text7:      dc.b "PULSE MAX",0
pti_text8:      dc.b "FILTERNUM",0
pti_text9:      dc.b "WAVEINDEX",0

printfilter:    lda #$00
                sta bgcolor
                ldx #13
                ldy #20
                jsr setxy
                lda #$01
                sta textcolor
                ldx #<ptf_text
                ldy #>ptf_text
                jsr printtext
                ldx #23
                ldy #20
                jsr setxy
                lda curfilter
                jsr printhex8
                lda #$0f
                sta textcolor
                lda curfilter
                asl
                asl
                sta temp1
                ldx #13
                ldy #22
                jsr setxy
                ldx #0
                jsr filtcursor
                ldx temp1
                lda filtertbl,x
                jsr printhex8
                ldx #16
                ldy #22
                jsr setxy
                ldx #1
                jsr filtcursor
                ldx temp1
                lda filtertbl+1,x
                jsr printhex8
                ldx #19
                ldy #22
                jsr setxy
                ldx #2
                jsr filtcursor
                ldx temp1
                lda filtertbl+2,x
                jsr printhex8
                ldx #22
                ldy #22
                jsr setxy
                ldx #3
                jsr filtcursor
                ldx temp1
                lda filtertbl+3,x
                jsr printhex8
                rts

filtcursor:     lda screennum
                cmp #SCREEN_FILTER
                bne filtcursoroff
                cpx filtervx
                bne filtcursoroff
                lda #$c0
                sta bgcolor
                rts
filtcursoroff:  lda #$00
                sta bgcolor
                rts

ptf_text:       dc.b "FILTER",0


printwave:      lda #$00
                sta bgcolor
                ldx #29
                ldy #8
                jsr setxy
                lda #$01
                sta textcolor
                ldx #<ptw_text
                ldy #>ptw_text
                jsr printtext
                lda wavevy
                sec
                sbc #$07
                sta temp1
                lda #10
                sta temp2
ptw_loop:       lda #$00
                sta bgcolor
                ldy temp2
                ldx #29
                jsr setxy
                lda temp1
                cmp wavelen
                bcs ptw_empty
                lda #$01
                sta textcolor
                lda #$00
                sta bgcolor
                lda temp1
                jsr printhex8
                lda #$0f
                sta textcolor
                ldx #32
                stx cursorx
                ldx #$00
                jsr wavecursor
                ldy temp1
                lda wavetbl,y
                jsr printhex8
                ldx #35
                stx cursorx
                ldx #$01
                jsr wavecursor
                ldy temp1
                lda notetbl,y
                jsr printhex8
                jmp ptw_done
ptw_empty:      ldx #<ptp_emptytxt
                ldy #>ptp_emptytxt
                jsr printtext
ptw_done:       inc temp1
                inc temp2
                lda temp2
                cmp #24
                bcc ptw_loop
                rts

wavecursor:     lda screennum
                cmp #SCREEN_WAVE
                bne wavecursoroff
                lda temp1
                cmp wavevy
                bne wavecursoroff
                cpx wavevx
                bne wavecursoroff
                lda #$c0
                sta bgcolor
                rts
wavecursoroff:  lda #$00
                sta bgcolor
                rts

ptw_text:       dc.b "WAVETABLE",0



trknumtbl1:     repeat 30
                dc.b "0"
                repend
                repeat 30
                dc.b "1"
                repend
                repeat 30
                dc.b "2"
                repend
                repeat 6
                dc.b "3"
                repend

trknumtbl2:     repeat 3
                dc.b "000111222333444555666777888999"
                repend
                dc.b "000111"

trknumtbl3:     repeat 32
                dc.b "123"
                repend




        ;Gethex - converts keypress to hex
gethex:         cmp #"0"
                bcc gh_hnotnum
                cmp #"9"+1
                bcs gh_hnotnum
                sbc #"0"-1
                jmp gh_h2
gh_hnotalpha:   lda #$ff
                sta hexdigit
                rts
gh_hnotnum:     cmp #"A"
                bcc gh_hnotalpha
                cmp #"F"+1
                bcs gh_hnotalpha
                sbc #"A"-11
gh_h2:          sta hexdigit
                rts


loadsong:       jsr askname
                lda namelength
                bne loadok
                rts
loadok:         jsr music+6
                lda #$00
                sta cursong
                sta curpatt
                sta trackmin
                lda #$02
                sta trackmax
                lda #$01
                sta curinstr
                lda #$00
                sta instrvy
                sta wavevy
                sta pattvy
                sta trackvy
                sta pattvx
                sta instrvx
                sta trackvx
                lda #<freemem
                sta freememlo
                lda #>freemem
                sta freememhi
                lda #$02
                ldy #$00
                ldx drivenumber
                jsr setlfs
                clc
                lda namelength
                ldx #<name
                ldy #>name
                jsr setnam
                jsr open
                ldx #$02
                jsr chkin
                ldy #$00
loadident:      jsr chrin                       ;Read identification (4 bytes)
                ldx status
                beq load_identok
                jmp load_error
load_identok:   sta ident,y
                iny
                cpy #$04
                bcc loadident
                ldy #$00
loadinfo:       jsr load_getbyte                ;Read authorinfo (96 bytes)
                sta info,y
                iny
                cpy #96
                bcc loadinfo
                jsr load_getbyte
                sta maxsongs                    ;Store amount of songs
                asl
                adc maxsongs
                sta maxtracks                   ;Store amount of tracks
                sta temp1                       ;Track counter
                lda #$00
                sta temp2
loadtracks:     ldy temp2
                lda freememlo
                sta trackadrlo,y
                lda freememhi
                sta trackadrhi,y
                jsr load_getbyte                ;Get track length
                clc
                adc #$01
                sta tracklen,y
                sta temp3
loadtrackloop:  jsr load_getbyte
                ldy #$00
                sta (freememlo),y
                jsr incfreemem
                dec temp3
                bne loadtrackloop
                inc temp2
                dec temp1
                bne loadtracks                  ;Loop until all tracks read
                lda #$00
                sta wavelen
                lda #$01
                sta temp1
                lda #<instrnames
                sta editlo
                lda #>instrnames
                sta edithi
loadinstrloop:  ldy temp1
                jsr load_getbyte
                sta instrad,y
                jsr load_getbyte
                sta instrsr,y
                jsr load_getbyte
                sta instrpulse,y
                jsr load_getbyte
                sta instrpulsespd,y
                jsr load_getbyte
                sta instrpulsemin,y
                jsr load_getbyte
                sta instrpulsemax,y
                jsr load_getbyte
                sta instrfilter,y
                jsr load_getbyte
                lsr
                sta instrwavelen,y
                sta temp3
                lda wavelen
                sta instrwaveindex,y
                lda #$10
                sta temp2
loadinstrname:  jsr load_getbyte                ;Load the 16-byte instrument
                ldy #$00                        ;name
                sta (editlo),y
                inc editlo
                bne lir_ok
                inc edithi
lir_ok:         dec temp2
                bne loadinstrname
loadwavetable:  ldy wavelen
                jsr load_getbyte
                sta wavetbl,y
                jsr load_getbyte
                sta notetbl,y
                inc wavelen
                dec temp3
                bne loadwavetable
                inc temp1
                lda temp1
                cmp #$20                        ;All 31 instruments read?
                bcs loadinstrdone
                jmp loadinstrloop
loadinstrdone:  jsr load_getbyte                ;Amount of patterns
                sta maxpatt
                sta temp1
                lda #$00
                sta temp2
loadpattloop:   lda #$00
                sta temp3
                jsr load_getbyte                ;Length of pattern
                sta temp4
loadpatt_divide:sec
                sbc #$03
                bcc loadpatt_ddone
                inc temp3
                bcs loadpatt_divide
loadpatt_ddone: ldy temp2
                lda temp3
                sta pattlen,y
                lda freememlo
                sta pattadrlo,y
                lda freememhi
                sta pattadrhi,y
loadpattbyteloop:
                jsr load_getbyte
                ldy #$00
                sta (freememlo),y
                jsr incfreemem
                dec temp4
                bne loadpattbyteloop
                inc temp2
                dec temp1
                bne loadpattloop
                ldy #$00
loadfilterloop: jsr load_getbyte
                sta filtertbl,y
                iny
                bne loadfilterloop
                jmp load_error          ;All done!

load_getbyte:   ldx status
                bne load_fileend
                jsr chrin
                dec $d020
                inc $d020
                rts
load_fileend:   pla
                pla
load_error:     lda #$02
                jsr close
                jsr clrchn
                rts

incfreemem:     inc freememlo
                bne ifm_done
                inc freememhi
ifm_done:       rts

savesong:       jsr askname
                lda namelength
                bne saveok
                rts
saveok:         jsr music+6
                lda #15
                ldx drivenumber
                ldy #15
                jsr setlfs
                clc
                lda namelength
                adc #$03
                ldx #<scratch
                ldy #>scratch
                jsr setnam
                jsr open
                lda #15
                jsr close
                lda #$02
                ldy #$01
                ldx drivenumber
                jsr setlfs
                lda namelength
                ldx #<name
                ldy #>name
                jsr setnam
                lda namelength
                jsr open
                ldx #$02
                jsr chkout
                ldy #$00
saveident:      lda ident,y
                jsr save_sendbyte                ;Write identification (4 bytes)
                iny
                cpy #$04
                bcc saveident
                ldy #$00
saveinfo:       lda info,y
                jsr save_sendbyte                ;Write authorinfo (96 bytes)
                iny
                cpy #96
                bcc saveinfo
                lda maxsongs                    ;Store amount of songs
                jsr save_sendbyte
                lda maxtracks
                sta temp1                       ;Track counter
                lda #$00
                sta temp2
savetracks:     ldy temp2
                lda trackadrlo,y
                sta freememlo
                lda trackadrhi,y
                sta freememhi
                lda tracklen,y
                sta temp3
                sec
                sbc #$01
                jsr save_sendbyte                ;Store track length
savetrackloop:  ldy #$00
                lda (freememlo),y
                jsr save_sendbyte
                jsr incfreemem
                dec temp3
                bne savetrackloop
                inc temp2
                dec temp1
                bne savetracks                  ;Loop until all tracks read
                lda #$01
                sta temp1
                lda #<instrnames
                sta editlo
                lda #>instrnames
                sta edithi
saveinstrloop:  ldy temp1
                lda instrad,y
                jsr save_sendbyte
                lda instrsr,y
                jsr save_sendbyte
                lda instrpulse,y
                jsr save_sendbyte
                lda instrpulsespd,y
                jsr save_sendbyte
                lda instrpulsemin,y
                jsr save_sendbyte
                lda instrpulsemax,y
                jsr save_sendbyte
                lda instrfilter,y
                jsr save_sendbyte
                lda instrwavelen,y
                sta temp3
                asl
                jsr save_sendbyte
                lda #$10
                sta temp2
saveinstrname:  ldy #$00                        ;Store instr.name
                lda (editlo),y
                jsr save_sendbyte
                inc editlo
                bne sir_ok
                inc edithi
sir_ok:         dec temp2
                bne saveinstrname
                ldy temp1
                lda instrwaveindex,y
                tay
savewavetable:  lda wavetbl,y                   ;Store wavetable
                jsr save_sendbyte
                lda notetbl,y
                jsr save_sendbyte
                iny
                dec temp3
                bne savewavetable
                inc temp1
                lda temp1
                cmp #$20                        ;All 31 instruments read?
                bcs saveinstrdone
                jmp saveinstrloop
saveinstrdone:  lda maxpatt
                sta temp1
                jsr save_sendbyte                ;Amount of patterns
                lda #$00
                sta temp2
savepattloop:   ldy temp2
                lda pattlen,y
                asl
                adc pattlen,y
                sta temp3
                jsr save_sendbyte                ;Length of pattern
                lda pattadrlo,y
                sta freememlo
                lda pattadrhi,y
                sta freememhi
savepattbyteloop:
                ldy #$00
                lda (freememlo),y
                jsr save_sendbyte
                jsr incfreemem
                dec temp3
                bne savepattbyteloop
                inc temp2
                dec temp1
                bne savepattloop
                ldy #$00
savefilterloop: lda filtertbl,y
                jsr save_sendbyte
                iny
                bne savefilterloop
                jmp load_error          ;All done!

save_sendbyte:  jsr chrout
                ldx status
                bne save_senderror
                dec $d020
                inc $d020
                rts
save_senderror: pla
                pla
save_done:      jmp load_error

askname:        lda #$00
                sta namelength
                ldx #$0f
                lda #$20
askname1:       sta name,x
                dex
                bpl askname1
                ldx #0
                ldy #24
                jsr setxy
                ldx #<asknametext
                ldy #>asknametext
                jsr printtext
asknameloop:    ldx #9
                ldy #24
                jsr setxy
                ldx #<name
                ldy #>name
                jsr printtext
                lda #$20
                sta $400+24*40+16+9
                ldx namelength
                lda $400+24*40+9,x
                ora #$c0
                sta $400+24*40+9,x
                jsr getkey
                cmp #13
                beq askname_end
                cmp #KEY_DEL
                bne askname_nodel
                lda namelength
                beq asknameloop
                dec namelength
                ldx namelength
                lda #$20
                sta name,x
                jmp asknameloop
askname_nodel:  cmp #$20
                bcc asknameloop
                and #$3f
                ldx namelength
                cpx #$10
                bcs asknameloop
                sta name,x
                inc namelength
                jmp asknameloop
askname_end:    ldx #$0f
askname_final:  lda name,x
                cmp #$20
                bcs askname_final2
                ora #$40
                sta name,x
askname_final2: dex
                bpl askname_final
                lda #24
                sta cursory
                jmp printemptyrow

getkey:         jsr getkey_delay
                jsr scnkey
                jsr getin
                cmp #$00
                bne getkey_done
                jmp getkey
getkey_done:    pha
                jsr gethex
                pla
                rts

getkey_delay:   ldy #6
gkd1:           ldx #$ff
gkd2:           dex
                bne gkd2
                dey
                bne gkd1
                rts

waitkey:        jsr getkey_delay
                jsr getkey_delay
                jsr scnkey
                jsr getin
                cmp #$00
                beq waitkey
                rts

initscreen:     lda #$00
                sta $d020
                sta $d021
                lda #$0b
                sta $d022
                lda #$0c
                sta $d023
                lda #$03
                sta $dd00
                lda #$08
                sta $d016
                lda #$5b                ;Extended colormode
                sta $d011
                lda #21
                sta $d018
                lda #$ff
                sta 650
clearscreen:    lda #$20
                ldx #$00
is_loop:        sta $0400,x
                sta $0500,x
                sta $0600,x
                sta $0700,x
                inx
                bne is_loop
                rts

        ;X=xposition, Y=yposition
setxy:          stx cursorx
                sty cursory
                rts

printemptyrow:  ldx #$00
                stx cursorx
                ldx #<emptyrow
                ldy #>emptyrow

        ;X=text address lo, Y=text address hi
printtext:      stx textlo
                sty texthi
printtextcont:  ldx cursory
                clc
                lda rowtbllo,x
                adc cursorx
                sta destlo
                lda rowtblhi,x
                adc #$00
                sta desthi
                ldy #$00
pt_loop:        lda (textlo),y
                beq pt_done
                and #$3f
                ora bgcolor
                sta (destlo),y
                clc
                lda desthi
                adc #$d4
                sta desthi
                lda textcolor
                sta (destlo),y
                sec
                lda desthi
                sbc #$d4
                sta desthi
                iny
                jmp pt_loop
pt_done:        iny
                tya
                clc
                adc textlo
                sta textlo
                lda texthi
                adc #$00
                sta texthi
                rts

        ;A=hex value
printhex8:      jsr converthex8
                ldx cursory
                clc
                lda rowtbllo,x
                adc cursorx
                sta destlo
                lda rowtblhi,x
                adc #$d4
                sta desthi
                lda textcolor
                ldy #$00
                sta (destlo),y
                iny
                sta (destlo),y
                dey
                lda desthi
                sec
                sbc #$d4
                sta desthi
                lda cursordigit
                beq printhex_left
                lda hexstring
                and #$3f
                ldy #$00
                sta (destlo),y
                lda hexstring+1
                and #$3f
                ora bgcolor
                iny
                sta (destlo),y
                rts
printhex_left:  lda hexstring
                and #$3f
                ora bgcolor
                ldy #$00
                sta (destlo),y
                lda hexstring+1
                and #$3f
                iny
                sta (destlo),y
                rts

converthex8:    sta hexvalue
                lsr
                lsr
                lsr
                lsr
                tax
                lda hexcodes,x
                sta hexstring
                lda hexvalue
                and #$0f
                tax
                lda hexcodes,x
                sta hexstring+1
                rts

initraster:     sei
                lda #$7f
                sta $dc0d
                lda #$01
                sta $d01a
                lda #<raster
                sta $0314
                lda #>raster
                sta $0315
                lda #$32
                sta $d012
                lda $dc0d
                cli
                rts

raster:         inc $d019
                nop
                nop
                nop
                nop
                nop
                nop
                nop
                nop
                inc $d020
                jsr music+3
                dec $d020
ras_notmax:     lda fastfwd
                beq ras_noplay
                dec fastfwd
                jsr music+3
                jsr music+3
                jsr music+3
ras_noplay:     lda cursorcolor
                and #$1f
                tax
                lda cursorcolortbl,x
                sta $d024
                inc cursorcolor
ras_skipflash:  jmp $ea81

cursorcolor:    dc.b 0
cursorcolortbl: dc.b 0,0,9,9,2,2,8,8
                dc.b 10,10,15,15,7,7,1,1
                dc.b 1,1,7,7,15,15,10,10
                dc.b 8,8,2,2,9,9,0,0

hexvalue:       dc.b 0
hexvalue2:      dc.b 0

hexstring:      dc.b "00",0
hexcodes:       dc.b "0123456789ABCDEF",0

scratch:        dc.b "S0:"
name:           dc.b "                ",0
namelength:     dc.b 0
drivenumber:    dc.b 8

cursorx:        dc.b 0
cursory:        dc.b 0
bgcolor:        dc.b 0
textcolor:      dc.b 1
keynum:         dc.b 0
hexdigit:       dc.b 0
fastfwd:        dc.b 0
playing:        dc.b 0

rowtbllo:
N               SET 0
                REPEAT 25
                dc.b <($400+40*N)
N               SET N+1
                REPEND

rowtblhi:
N               SET 0
                REPEAT 25
                dc.b >($400+40*N)
N               SET N+1
                REPEND

emptyrow:       dc.b "                                        ",0
titletext:      dc.b "GOATTRACKER V1.3 SONG TWEAK UTILITY     ",0
helptext:       dc.b "L=LOAD SONG S=SAVE SONG F1=SWITCH SCREEN",0
helptext2:      dc.b "SPC=PLAY/STOP :;=SELECT PATT/SONG/INSTR.",0
asknametext:    dc.b "FILENAME:",0

pattadrlo:      ds.b 256,<freemem
pattadrhi:      ds.b 256,>freemem

trackadrlo:     ds.b 32*3,<freemem
trackadrhi:     ds.b 32*3,>freemem

pattlen:        dc.b 1
                ds.b 255,0
tracklen:       dc.b 1,1,1
                ds.b 31*3,0

trackvx:        dc.b 0
trackvy:        dc.b 0
trackmin:       dc.b 0
trackmax:       dc.b 2

pattvx:         dc.b 0
pattvy:         dc.b 0

instrvx:        dc.b 0
instrvy:        dc.b 0

wavevx:         dc.b 0
wavevy:         dc.b 0

filtervx:       dc.b 0

maxpatt:        dc.b 1
maxsongs:       dc.b 1
maxtracks:      dc.b 3
maxinstr:       dc.b 32

screennum:      dc.b SCREEN_SONG
curpatt:        dc.b 0
cursong:        dc.b 0
curinstr:       dc.b 1
cursordigit:    dc.b 0
curfilter:      dc.b 0

instrad:        ds.b 32,0
instrsr:        ds.b 32,0
instrpulse:     ds.b 32,0
instrpulsespd:  ds.b 32,0
instrpulsemin:  ds.b 32,0
instrpulsemax:  ds.b 32,0
instrfilter:    ds.b 32,0
instrwavelen:   ds.b 32,0
instrwaveindex: ds.b 32,0

wavelen:        dc.b 64

wavetbl:        ds.b 256,0
notetbl:        ds.b 256,0
filtertbl:      ds.b 256,0

instrnames:     ds.b 16*31,$20

ident:          ds.b 4,0
info:           ds.b 96,0

;-------------------------------------------------------------------------------
; GoatTracker V1.3 standard playroutine.
;-------------------------------------------------------------------------------

        ; Defines for the music data.
        ; Patterndata 1st byte: repeat prefix or note

C0              = $00
CIS0            = $01
D0              = $02
DIS0            = $03
E0              = $04
F0              = $05
FIS0            = $06
G0              = $07
GIS0            = $08
A0              = $09
B0              = $0a
H0              = $0b
C1              = $0c
CIS1            = $0d
D1              = $0e
DIS1            = $0f
E1              = $10
F1              = $11
FIS1            = $12
G1              = $13
GIS1            = $14
A1              = $15
B1              = $16
H1              = $17
C2              = $18
CIS2            = $19
D2              = $1a
DIS2            = $1b
E2              = $1c
F2              = $1d
FIS2            = $1e
G2              = $1f
GIS2            = $20
A2              = $21
B2              = $22
H2              = $23
C3              = $24
CIS3            = $25
D3              = $26
DIS3            = $27
E3              = $28
F3              = $29
FIS3            = $2a
G3              = $2b
GIS3            = $2c
A3              = $2d
B3              = $2e
H3              = $2f
C4              = $30
CIS4            = $31
D4              = $32
DIS4            = $33
E4              = $34
F4              = $35
FIS4            = $36
G4              = $37
GIS4            = $38
A4              = $39
B4              = $3a
H4              = $3b
C5              = $3c
CIS5            = $3d
D5              = $3e
DIS5            = $3f
E5              = $40
F5              = $41
FIS5            = $42
G5              = $43
GIS5            = $44
A5              = $45
B5              = $46
H5              = $47
C6              = $48
CIS6            = $49
D6              = $4a
DIS6            = $4b
E6              = $4c
F6              = $4d
FIS6            = $4e
G6              = $4f
GIS6            = $50
A6              = $51
B6              = $52
H6              = $53
C7              = $54
CIS7            = $55
D7              = $56
DIS7            = $57
E7              = $58
F7              = $59
FIS7            = $5a
G7              = $5b
GIS7            = $5c
A7              = $5d
KEYOFF          = $5e           ;Keyoff clears the gatebit
REST            = $5f
NOCMD           = $60           ;Instrument & command byte do not exist
FIRSTPACKEDREST = $c0
PACKEDREST      = $00
ENDPATT         = $ff

        ; Patterndata 2nd byte: Instrument number and command ORed with each
        ; other

INST0           = $00           ;There's a maximum of 32 instruments
INST1           = $08
INST2           = $10
INST3           = $18
INST4           = $20
INST5           = $28
INST6           = $30
INST7           = $38
INST8           = $40
INST9           = $48
INST10          = $50
INST11          = $58
INST12          = $60
INST13          = $68
INST14          = $70
INST15          = $78
INST16          = $80
INST17          = $88
INST18          = $90
INST19          = $98
INST20          = $a0
INST21          = $a8
INST22          = $b0
INST23          = $b8
INST24          = $c0
INST25          = $c8
INST26          = $d0
INST27          = $d8
INST28          = $e0
INST29          = $e8
INST30          = $f0
INST31          = $f8

        ; Orderlist commands

REPEAT          = $d0
TRANSDOWN       = $e0
TRANSUP         = $f0
LOOPSONG        = $ff

        ; Used zeropage temp variables

mt_temp1        = $fb
mt_temp2        = $fc
mt_temp3        = $fd
mt_temp4        = $fe

music           = $2400

                org music
                jmp init
                jmp play
                jmp stop

init:           sta init_adc+1
                asl
init_adc:       adc #$00
                sta mt_chnloop+1
                rts

stop:           lda #$80
                sta mt_chnloop+1
                lda #$00
                sta $d404
                sta $d404+7
                sta $d404+14
                rts

mt_tick0cmdtbllo:dc.b <mt_cmddowavearp
                dc.b <mt_cmddowavearp
                dc.b <mt_cmddowavearp
                dc.b <mt_starttoneportamento
                dc.b <mt_cmddowavearp
                dc.b <mt_setfilter
                dc.b <mt_setsustain
                dc.b <mt_settempo

mt_contcmdtbllo:dc.b <mt_portaup
                dc.b <mt_portadown
                dc.b <mt_toneportamento
                dc.b <mt_vibrato
                dc.b <mt_cmddonothing
                dc.b <mt_cmddonothing
                dc.b <mt_cmddonothing

play:           ldx #$00
mt_chnloop:     lda #$00
                bmi mt_noinit
                sta mt_chnsongnum,x
                inc mt_chnloop+1
                lda #$00
                sta mt_chnwave,x
                sta mt_chntrans,x
                sta mt_chnwavetbl,x
                sta mt_chnsongptr,x
                sta mt_chnpackrest,x
                sta mt_chnrepeat,x
                lda #$05
                sta mt_chntick,x
                sta mt_chntempo,x
                lda #ENDPATT
                sta mt_chnnewnote,x
                sta mt_chnpattptr,x
                txa
                bne mt_nofiltinit
                sta $d415                       ;Reset cutoff lowbyte
                jsr mt_setfiltersub             ;Set filter 0
mt_nofiltinit:  jmp mt_nextchn
mt_noinit:      cmp #$80
                bne mt_nostop
                rts
mt_nostop:      ldy mt_chntick,x
                bne mt_nonewnotes
                jmp mt_newnotes
mt_nonewnotes:  bpl mt_noreload
mt_inittick:    ldy mt_chntempo,x
                cpy #$01
                bcc mt_funk0
                bne mt_noreload
mt_funk1:       lda #$00                        ;Funktempo
                sta mt_chntempo,x
                lda filtertbl+2
                and #$0f
                tay
                dey
                jmp mt_noreload
mt_funk0:       lda #$01
                sta mt_chntempo,x
                lda filtertbl+2
                lsr
                lsr
                lsr
                lsr
                tay
                dey
mt_noreload:    dey
                tya
                sta mt_chntick,x
                lda mt_chnpattptr,x             ;Check for pattern end
                cmp #ENDPATT
                bcc mt_effects
mt_nextpatt:    ldy mt_chnsongnum,x
                lda trackadrlo,y
                sta mt_temp1
                lda trackadrhi,y
                sta mt_temp2
                ldy mt_chnsongptr,x
mt_nextpattloop:lda (mt_temp1),y
                iny
                cmp #REPEAT
                bcc mt_noloopsong
                cmp #TRANSDOWN
                bcc mt_repeat
                cmp #LOOPSONG
                bcc mt_trans
mt_loopsong:    lda (mt_temp1),y
                tay
                bcs mt_nextpattloop
mt_repeat:      sbc #REPEAT-1
                sta mt_chnrepeat,x
                jmp mt_nextpattloop
mt_trans:       sbc #TRANSUP-1
                sta mt_chntrans,x
                jmp mt_nextpattloop
mt_noloopsong:  sta mt_chnpattnum,x
                lda mt_chnrepeat,x
                beq mt_norepeat
                dec mt_chnrepeat,x
                dey
mt_norepeat:    tya
                sta mt_chnsongptr,x
                inc mt_chnpattptr,x
                lda mt_chnnewnote,x
                bpl mt_effects2
                jmp mt_cmddowavearp2

mt_effects:     lda mt_chnnewnote,x
                bmi mt_pulsemod
mt_effects2:    dec mt_chnnewnote,x
                bne mt_newnoteinit
                beq mt_pulseok                    ;Start note now

mt_newnoteinit: lda #$00
                sta mt_chnarpcount,x
                ldy mt_chninstnum,x
                lda instrpulse,y
                and #$fe
                beq mt_skippulse
                sta mt_chnpulse,x
                lda #$00
                sta mt_chnpulsedir,x
mt_skippulse:   lda instrwaveindex,y
                clc
                adc #$01
                sta mt_chnwavetbl,x
                lda instrfilter,y
                beq mt_nofilterchange
                jsr mt_setfiltersub
mt_nofilterchange:
                jmp mt_nextchn

mt_pulsemod:    ldy mt_chninstnum,x
                lda mt_chnpulsedir,x
                lsr
                lda instrpulsespd,y
                php
                asl
                adc #$00
                asl
                adc #$00
                asl
                adc #$00
                asl
                adc #$00
                plp
                pha
                and #$f0
                sta mt_temp1
                pla
                and #$0f
                sta mt_temp2
                bcs mt_pulsesub
mt_pulseadd:    lda mt_chnpulsedir,x
                clc
                adc mt_temp1
                pha
                lda mt_chnpulse,x
                adc mt_temp2
                sta mt_chnpulse,x
                cmp instrpulsemax,y
                jmp mt_pulsedone
mt_pulsesub:    lda mt_chnpulsedir,x
                sec
                sbc mt_temp1
                pha
                lda mt_chnpulse,x
                sbc mt_temp2
                sta mt_chnpulse,x
                cmp instrpulsemin,y
mt_pulsedone:   pla
                and #$f0
                adc #$00
                sta mt_chnpulsedir,x
mt_pulseok:     ldy mt_chnwavetbl,x
                bne mt_dowavetbl
                ldy mt_chncommand,x             ;Do only continuous effects
                beq mt_arpeggio                 ;Arpeggio is most common so
                lda #$00                        ;optimize for it
                sta mt_temp2                    ;Clear speed highbyte
                lda mt_contcmdtbllo-1,y
                sta mt_contjump+1
                lda mt_chncmddata,x
mt_contjump:    jmp mt_portaup

mt_dowavetbl:   lda wavetbl-1,y
                beq mt_skipwave
                sta mt_chnwave,x
mt_skipwave:    lda notetbl-1,y
                bmi wavetblabs
                clc
                adc mt_chnnote,x
wavetblabs:     and #$7f
                sta mt_temp1
                lda wavetbl,y
                cmp #$ff
                bcc mt_nowaveend
                lda notetbl,y
                beq mt_nowaveloop
                ldy mt_chninstnum,x
                adc instrwaveindex,y             ;Carry is cleared
                adc #$ff
                bne mt_nowaveloop
mt_nowaveend:   iny
                tya
mt_nowaveloop:  sta mt_chnwavetbl,x
                ldy mt_temp1
                bpl mt_arpfreq

mt_arpeggio:    lda mt_chncmddata,x
                beq mt_nextchn
                eor #$80
                asl
                lda mt_chnarpcount,x
                pha
                adc #$01
                cmp #$06
                bcc mt_arpnotover
                lda #$00
mt_arpnotover:  sta mt_chnarpcount,x
                pla
                lsr
                cmp #$01
                bcc mt_arp1
                bne mt_arp0
mt_arp2:        lda mt_chncmddata,x
                and #$0f
                bpl mt_arpfreq2
mt_arp0:        lda #$00
                bpl mt_arpfreq2
mt_arp1:        lda mt_chncmddata,x
                and #$70
                lsr
                lsr
                lsr
                lsr
mt_arpfreq2:    clc
                adc mt_chnnote,x
                tay
mt_arpfreq:     lda mt_freqtbllo,y
                sta mt_chnfreqlo,x
                lda mt_freqtblhi,y
                sta mt_chnfreqhi,x

mt_nextchn:     lda mt_chnfreqlo,x
                sta $d400,x
                lda mt_chnfreqhi,x
                sta $d401,x
                lda mt_chnwave,x
                sta $d404,x
                lda mt_chnnewnote,x
                bne mt_noadsr
                ldy mt_chninstnum,x
                lda instrad,y
                sta $d405,x
                lda instrsr,y
                ldy mt_chncommand,x
                cpy #$06
                bne mt_defaultsr
                lda mt_chncmddata,x
mt_defaultsr:   sta $d406,x
                dec mt_chnnewnote,x
mt_noadsr:      lda mt_chnpulse,x
                asl
                asl
                asl
                asl
                sta mt_temp1
                lda mt_chnpulsedir,x
                lsr
                lsr
                lsr
                lsr
                ora mt_temp1
                sta $d402,x
                lda mt_chnpulse,x
                lsr
                lsr
                lsr
                lsr
                sta $d403,x
mt_noloadregs:  cpx #14
                bcs mt_alldone
                txa
                adc #$07
                tax
                jmp mt_chnloop
mt_alldone:     lda #$ff
                sta mt_chnloop+1
mt_filtcutoff:  lda #$00
                clc
mt_filtcutoffadd:adc #$00
mt_setcutoff:   sta mt_filtcutoff+1
                sta $d416
                rts

mt_newnotes:    dec mt_chntick,x
                ldy mt_chnpattnum,x
                lda pattadrlo,y
                sta mt_temp1
                lda pattadrhi,y
                sta mt_temp2
                ldy mt_chnpattptr,x
                lda (mt_temp1),y
                iny
                sta mt_temp3
                lda (mt_temp1),y
                lsr
                lsr
                lsr
                beq mt_skipinst                 ;Instrument number 0 lets
                sta mt_chninstnum,x             ;the instrument stay the same
mt_skipinst:    lda (mt_temp1),y
                and #$07
                sta mt_chncommand,x
                iny
                lda (mt_temp1),y
                sta mt_chncmddata,x
                iny
mt_nocmd:       lda (mt_temp1),y
                cmp #ENDPATT
                beq mt_endpatt
                tya
mt_endpatt:     sta mt_chnpattptr,x
                ldy mt_chncommand,x
                lda mt_temp3
                cmp #KEYOFF                   ;Keyoff or rest?
                beq mt_keyoff
                bcs mt_rest
mt_normalnote:  adc mt_chntrans,x
                sta mt_chnnote,x
                cpy #$03                      ;Or toneportamento?
                beq mt_rest
                ldy mt_chninstnum,x
                lda instrpulse,y            ;Pulsewidth bit 0: hardrestart
                lsr                           ;flag
                lda #$02
                sta mt_chnnewnote,x
                bcs mt_keyoff
                lda #$00
                sta $d405,x
                sta $d406,x
mt_keyoff:      lda mt_chnwave,x              ;Keyoff: reset gatebit
                and #$fe
                sta mt_chnwave,x
mt_rest:        ldy mt_chncommand,x
                lda mt_tick0cmdtbllo,y
                sta mt_tick0jump+1
                lda mt_chncmddata,x
mt_tick0jump:   jmp mt_setfilter

mt_freqadd:     lda mt_chnfreqlo,x
                adc mt_temp1
                sta mt_chnfreqlo,x
                lda mt_chnfreqhi,x
                adc mt_temp2
                sta mt_chnfreqhi,x
                rts

mt_freqsub:     lda mt_chnfreqlo,x
                sbc mt_temp1
                sta mt_chnfreqlo,x
                lda mt_chnfreqhi,x
                sbc mt_temp2
                sta mt_chnfreqhi,x
                rts

mt_cmpfreq:     lda mt_chnfreqhi,x
                cmp mt_freqtblhi,y
                bne mt_cmpfreqdone
                lda mt_chnfreqlo,x
                cmp mt_freqtbllo,y
mt_cmpfreqdone: rts

mt_setfiltersub:asl
                asl
                tay
                lda filtertbl,y
                sta $d417
                lda filtertbl+1,y
                sta $d418
                lda filtertbl+2,y
                beq mt_sfsskip
                sta mt_filtcutoff+1
mt_sfsskip:     lda filtertbl+3,y
                sta mt_filtcutoffadd+1
                rts

mt_makespeed:   asl
                rol mt_temp2
                asl
                rol mt_temp2
                sta mt_temp1
                rts

        ;Effects. All entrypoints must reside on the same page!

mt_cmddonothing:jmp mt_nextchn

mt_cmddowavearp:lda mt_chnnewnote,x
                bpl mt_cmddonothing
mt_cmddowavearp2:ldy mt_chnwavetbl,x
                beq mt_cdwa_nowave
                jmp mt_dowavetbl
mt_cdwa_nowave: ldy mt_chncommand,x
                bne mt_cmddonothing
                jmp mt_arpeggio

mt_starttoneportamento:
                lda #$00
                sta mt_chnarpcount,x
                beq mt_cmddowavearp

mt_setfilter:   jsr mt_setfiltersub
                jmp mt_cmddowavearp

mt_setcutoffadd:sta mt_filtcutoffadd+1
                jmp mt_cmddowavearp

mt_setsustain:  ldy mt_chnnewnote,x
                bpl mt_cmddonothing
                sta $d406,x
                jmp mt_cmddowavearp2

mt_settempo:    cmp #$c0
                bcs mt_cmddowavearp
                sec
                sbc #$01
                bmi mt_settempoone
                sta mt_chntempo
                sta mt_chntempo+7
                sta mt_chntempo+14
                bpl mt_cmddowavearp
mt_settempoone: cmp #$c0
                bcs mt_timingmark
                and #$7f
                sta mt_chntempo,x
                bpl mt_cmddowavearp
mt_timingmark:  sta mt_temp4
                bcs mt_cmddowavearp

mt_portaup:     jsr mt_makespeed
                clc
mt_dofreqadd:   jsr mt_freqadd
                jmp mt_nextchn
mt_portadown:   jsr mt_makespeed
                sec
mt_dofreqsub:   jsr mt_freqsub
                jmp mt_nextchn

mt_vibrato:     asl
                adc #$00
                asl
                adc #$00
                asl
                adc #$00
                asl
                adc #$00
                sta mt_temp1
                and #$0f
                sta mt_temp3
                lda mt_chnarpcount,x
                bmi mt_novibdir
                cmp mt_temp3
                bcc mt_novibdir2
                beq mt_novibdir
                eor #$ff
mt_novibdir:    clc
mt_novibdir2:   adc #$02
mt_vibdone:     sta mt_chnarpcount,x
                lsr
                bcc mt_dofreqadd
                bcs mt_dofreqsub

mt_toneportamento:
                ldy mt_chnnote,x
                pha
                jsr mt_makespeed
                pla
                beq mt_tpfound
                jsr mt_cmpfreq
                beq mt_tpalldone
                bcs mt_tpdown
mt_tpup:        jsr mt_freqadd
                jsr mt_cmpfreq
                bcs mt_tpfound
mt_tpalldone:
mt_tpnotyet:    jmp mt_nextchn
mt_tpdown:      jsr mt_freqsub
                jsr mt_cmpfreq
                bcs mt_tpnotyet
mt_tpfound:     jmp mt_arpfreq

                if (mt_cmddonothing & $ff00)!=(mt_toneportamento & $ff00)
                err
                endif

mt_chnnote:     dc.b 0
mt_chnfreqlo:   dc.b 0
mt_chnfreqhi:   dc.b 0
mt_chnnewnote:  dc.b 0
mt_chncommand:  dc.b 0
mt_chncmddata:  dc.b 0
mt_chninstnum:  dc.b INST1

                dc.b 0,0,0,0,0,0,INST1
                dc.b 0,0,0,0,0,0,INST1

mt_chnwave:     dc.b 0
mt_chnwavetbl:  dc.b 0
mt_chnpulse:    dc.b 0
mt_chnpulsedir: dc.b 0
mt_chnarpcount: dc.b 0
mt_chnpackrest: dc.b 0
mt_chnrepeat:   dc.b 0

                dc.b 0,0,0,0,0,0,0
                dc.b 0,0,0,0,0,0,0

mt_chnsongptr:  dc.b 0
mt_chnsongnum:  dc.b 0
mt_chnpattptr:  dc.b 0
mt_chnpattnum:  dc.b 0
mt_chntick:     dc.b 0
mt_chntempo:    dc.b 0
mt_chntrans:    dc.b 0

                dc.b 0,0,0,0,0,0,0
                dc.b 0,0,0,0,0,0,0

mt_freqtblhi:   dc.b $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$02
                dc.b $02,$02,$02,$02,$02,$02,$03,$03,$03,$03,$03,$04
                dc.b $04,$04,$04,$05,$05,$05,$06,$06,$06,$07,$07,$08
                dc.b $08,$09,$09,$0a,$0a,$0b,$0c,$0c,$0d,$0e,$0f,$10
                dc.b $11,$12,$13,$14,$15,$17,$18,$19,$1b,$1d,$1e,$20
                dc.b $22,$24,$26,$29,$2b,$2e,$30,$33,$36,$3a,$3d,$41
                dc.b $45,$49,$4d,$52,$57,$5c,$61,$67,$6d,$74,$7b,$82
                dc.b $8a,$92,$9b,$a4,$ae,$b8,$c3,$cf,$db,$e8,$f6,$ff

mt_freqtbllo:   dc.b $15,$25,$36,$49,$5c,$71,$87,$9f,$b7,$d1,$ed,$0a
                dc.b $2a,$4a,$6d,$92,$b9,$e3,$0f,$3e,$6f,$a3,$db,$15
                dc.b $54,$95,$db,$25,$73,$c7,$1e,$7c,$de,$47,$b6,$2b
                dc.b $a8,$2b,$b7,$4b,$e7,$8e,$3d,$f8,$bd,$8e,$6c,$57
                dc.b $50,$57,$6e,$96,$cf,$1c,$7b,$f0,$7b,$1d,$d8,$ae
                dc.b $a0,$af,$dd,$2d,$9f,$38,$f7,$e0,$f6,$3b,$b1,$5d
                dc.b $40,$5e,$bb,$5a,$3f,$70,$ef,$c1,$ed,$76,$63,$ba
                dc.b $80,$bc,$76,$b4,$7f,$e0,$de,$83,$da,$ed,$c7,$ff


freemem:
